﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Nixory - antispyware tool 
## Version: 1.0.3

##Released under GNU General Public License v2


import pygtk, gtk
pygtk.require('2.0')
from pango import ELLIPSIZE_END
from winmodules import *
from os import path, listdir, remove
from ConfigParser import NoOptionError
from time import localtime
from locale import getpreferredencoding
from pysqlite2 import dbapi2 as sqlite
from activeshield import actshield

def winshow(widget, destroyw, delete_event, languageconfig, globalconfig, defconfig, nametheme, trwin):
    
        
    def scan(widget, *items):
      #Stop if use has closed this window
      global stop
      if stop: 
          pass
      else:
       #Reset GUI
       scansbut.set_sensitive(False)
       statstore.set_value(statstore.get_iter(0), 1, 0)
       statstore.set_value(statstore.get_iter(4), 1, 0)
       
       #GLobal variables
       global foundobj
       foundobj = []
       whitelist = globalconfig.get("USER","whitelist").split(';')
       blacklist = defconfig.get("BLACKLIST","blacklist").split(';')
       del whitelist[-1]
       heurkeys = defconfig.get("HEUR","keys").split(';')
       
       #Part of progress for each profile
       progressunit = 100 / profilenum
       
       #profiles couldn't be scanned
       unaccprof = 0
       scannprof = 0
       id = 0

       #FIREFOX PROFILES SCAN
       for firefoxprof in profiledict["firefox"]:
         if stop:
             break
         else:          
          #Check if database is accessible
          success = 1
          totcookies = 0
          progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_connecting_firefox')))

          #The next step may take a while, so we force a gui update here
          while gtk.events_pending():
            gtk.main_iteration(False)
          try:
            conn = sqlite.connect(firefoxprof[1], timeout=1.0) #Wait 1 second
            curr = conn.cursor()
            curr.execute("SELECT host, name FROM moz_cookies")
            profcookie = curr.fetchall()
            totcookies = len(profcookie)
          except:
               success = 0
          
          if success:
              #DO scan here
              point = 0
              for cookie in profcookie:
                 if stop: 
                     break
                 else:

                    #Update progress bar
                    progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_scanning').replace('%cookiename', cookie[1])))
                    
                    #Check whether the cookie is present in the whitelist
                    if bool(int(globalconfig.get('PREFERENCES', 'white_ac'))) and cookie[0] in whitelist:
                            #Ignore this cookie
                            statstore.set_value(statstore.get_iter(4), 1, statstore.get_value(statstore.get_iter(4), 1) + 1)
                    
                    #If not, check if it is in the blacklist
                    elif cookie[0] in blacklist:
                            #Cookie spec: browser, id, type (0=potential), name, host
                            foundobj.append(("firefox", id, 1, cookie[1], cookie[0]))
                         
                            #Add cookie found
                            statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)
                            statstore.set_value(statstore.get_iter(2), 1, statstore.get_value(statstore.get_iter(2), 1) + 1)
                    
                    #If heuristic is enabled check keys
                    elif bool(int(globalconfig.get('PREFERENCES', 'heur_ac'))):
                           for key in heurkeys:
                               if key in cookie[0]:
    
                                   #Cookie spec: browser, id, type (0=potential), name, host
                                   foundobj.append(("firefox", id, 0, cookie[1], cookie[0]))
                                   
                                   #Add cookie found
                                   statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)
                                   statstore.set_value(statstore.get_iter(3), 1, statstore.get_value(statstore.get_iter(3), 1) + 1)

                               
                    
                    #Add cookie checked
                    statstore.set_value(statstore.get_iter(0), 1, statstore.get_value(statstore.get_iter(0), 1) + 1)

                 
                    #Set progress
                    point += 1
                    fraction = 0
                    fraction += progressunit * (scannprof + unaccprof) 
                    fraction += (progressunit / float(totcookies)) * point
                    bar1.set_fraction(fraction / 100.0)
                    bar1.set_text(str(int(fraction)) + '%')
                
                    while gtk.events_pending():
                      gtk.main_iteration(False)
                  
                  
              
              #End scanning
              curr.close()
              conn.close()
              id += 1
              scannprof += 1
          
          else:
              #Could not scan this profile
              curr.close()
              conn.close()
              id += 1
              unaccprof += 1
          
          
       #Reset id
       id = 0
              
       #GOOGLE CHROME PROFILES SCAN
       for chromeprof in profiledict["chrome"]:
         if stop:
             break
         else:          
          #Check if database is accessible
          success = 1
          totcookies = 0
          progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_connecting_chrome')))

          #The next step may take a while, so we force a gui update here
          while gtk.events_pending():
            gtk.main_iteration(False)
          try:
            conn = sqlite.connect(chromeprof[1])
            curr = conn.cursor()
            curr.execute("SELECT host_key, name FROM cookies")
            profcookie = curr.fetchall()
            totcookies = len(profcookie)
          except:
               success = 0
          
          if success:
              #DO scan here
              point = 0
              for cookie in profcookie:
                 if stop: 
                     break
                 else:

                    #Update progress bar
                    progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_scanning').replace('%cookiename', cookie[1])))
                    
                    #Check whether the cookie is present in the whitelist
                    if bool(int(globalconfig.get('PREFERENCES', 'white_ac'))) and cookie[0] in whitelist:
                            #Ignore this cookie
                            statstore.set_value(statstore.get_iter(4), 1, statstore.get_value(statstore.get_iter(4), 1) + 1)
                    
                    #If not, check if it is in the blacklist
                    elif cookie[0] in blacklist:
                            #Cookie spec: browser, id, type (0=potential), name, host
                            foundobj.append(("chrome", id, 1, cookie[1], cookie[0]))
                         
                            #Add cookie found
                            statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)
                            statstore.set_value(statstore.get_iter(2), 1, statstore.get_value(statstore.get_iter(2), 1) + 1)
                    
                    #If heuristic is enabled check keys
                    elif bool(int(globalconfig.get('PREFERENCES', 'heur_ac'))):
                           for key in heurkeys:
                               if key in cookie[0]:
    
                                   #Cookie spec: browser, id, type (0=potential), name, host
                                   foundobj.append(("chrome", id, 0, cookie[1], cookie[0]))
                                   
                                   #Add cookie found
                                   statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)
                                   statstore.set_value(statstore.get_iter(3), 1, statstore.get_value(statstore.get_iter(3), 1) + 1)

                               
                    
                    #Add cookie checked
                    statstore.set_value(statstore.get_iter(0), 1, statstore.get_value(statstore.get_iter(0), 1) + 1)

                 
                    #Set progress
                    point += 1
                    fraction = 0
                    fraction += progressunit * (scannprof + unaccprof) 
                    fraction += (progressunit / float(totcookies)) * point
                    bar1.set_fraction(fraction / 100.0)
                    bar1.set_text(str(int(fraction)) + '%')
                
                    while gtk.events_pending():
                      gtk.main_iteration(False)
                  
                  
              
              #End scanning
              curr.close()
              conn.close()
              id += 1
              scannprof += 1
          
          else:
              #Could not scan this profile
              curr.close()
              conn.close()
              id += 1
              unaccprof += 1
              
       #Reset id
       id = 0
              
       #IE SCAN ROUTINE       
       for ieprof in profiledict["ie"]:
         if stop:
             break
         else:          
          #Check if directory is accessible
          success = 1
          totcookies = 0
          progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_connecting_ie')))

          #The next step may take a while, so we force a gui update here
          while gtk.events_pending():
            gtk.main_iteration(False)
          try:
            filelist = listdir(ieprof[1])
          except:
               success = 0
          
          if success:
              #Filter files (only .txt and files)
              delist = []
              for file in filelist:
                  if not path.isfile(ieprof[1] + "\\" + file) or (file[-4:] != ".txt"): 
                      delist.append(file)   #Not a file.txt
              
              for file in delist:   
                 del filelist[filelist.index(file)]
         
              totcookies = len(filelist)
              
              #DO scan here
              point = 0
              for cookiefile in filelist:
                 if stop: 
                     break
                 else:
                  
                  #Cookie file read
                  try:
                     cookieio = open(ieprof[1] + "\\" + cookiefile, "r")
                  except:
                      #skip file
                      pass
                  else:
                    cookiecont = cookieio.read()
                    cookiecont = cookiecont.split('*\n')
                    del cookiecont[-1]
                  
                    #analize content
                    for cookie in cookiecont:
                      #vars
                      cookie = cookie.split('\n')
                      cookie[2] = cookie[2].replace("/", "")

                      #Update progress bar
                      progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_scanning').replace('%cookiename', cookie[0])))
                    
                      #Check whether the cookie is present in the whitelist
                      if bool(int(globalconfig.get('PREFERENCES', 'white_ac'))) and ((cookie[2] in whitelist) or ('.' + cookie[2] in whitelist)):
                            #Ignore this cookie
                            statstore.set_value(statstore.get_iter(4), 1, statstore.get_value(statstore.get_iter(4), 1) + 1)
                    
                      #If not, check if it is in the blacklist
                      #Internet explorer has the bad habit to remove the dot at the beginning of each host, so let's add it
                      elif (cookie[2] in blacklist) or ('.' + cookie[2] in blacklist):
                            #Cookie spec: browser, id, type (0=potential), name, host, filename (IE Only)
                            foundobj.append(("ie", id, 1, cookie[0], cookie[2], cookiefile))
                         
                            #Add cookie found
                            statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)
                            statstore.set_value(statstore.get_iter(2), 1, statstore.get_value(statstore.get_iter(2), 1) + 1)
                    
                      #If heuristic is enabled check keys
                      elif bool(int(globalconfig.get('PREFERENCES', 'heur_ac'))):
                           for key in heurkeys:
                               if key in cookie[2]:
    
                                   #Cookie spec: browser, id, type (0=potential), name, host
                                   foundobj.append(("ie", id, 0, cookie[0], cookie[2], cookiefile))
                                   
                                   #Add cookie found
                                   statstore.set_value(statstore.get_iter(1), 1, statstore.get_value(statstore.get_iter(1), 1) + 1)
                                   statstore.set_value(statstore.get_iter(3), 1, statstore.get_value(statstore.get_iter(3), 1) + 1)
                    
                    
                      #Add cookie checked
                      statstore.set_value(statstore.get_iter(0), 1, statstore.get_value(statstore.get_iter(0), 1) + 1)
                      
                      #Force GUI update
                      while gtk.events_pending():
                            gtk.main_iteration(False)

                 
                  #Set progress
                  point += 1
                  fraction = 0
                  fraction += progressunit * (scannprof + unaccprof) 
                  fraction += (progressunit / float(totcookies)) * point
                  bar1.set_fraction(fraction / 100.0)
                  bar1.set_text(str(int(fraction)) + '%')
                   
                  #Close connection
                  cookieio.close()
                
                  while gtk.events_pending():
                      gtk.main_iteration(False)
                  
                  
              
              #End scanning
              id += 1
              scannprof += 1
          
          else:
              #Could not scan this profile
              id += 1
              unaccprof += 1
              
              
       
       #Update stats
       globalconfig.set('GENERAL', 'num_scans', str(int(globalconfig.get('GENERAL', 'num_scans')) + 1))
       globalconfig.set('GENERAL', 'num_found_obj', str(int(globalconfig.get('GENERAL', 'num_found_obj')) + int(statstore.get_value(statstore.get_iter(1), 1))))
       globalconfig.write(open('etc/gconfig.cfg', 'w'))
        
       #Enable buttons

       ##If objects were found
       if len(foundobj) > 0:
           rmbut.set_sensitive(True)
       else:
           scansbut.set_sensitive(True)
        
       #Update progress lab
       progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_end')))
       bar1.set_fraction(1.0)
       bar1.set_text('100%')
       
       #Show warning if profiles could not be scanned
       if unaccprof > 0: show_error(languageconfig.get('WINSCAN','error_profiles').replace("NUM", str(unaccprof)), win, languageconfig.get('WINSCAN','error_title'), warning=True)
       

       #Write eventlog
       write_eventlog('opt_s', 'scan_succ')

       #Write scanlog if necessary
       if int(globalconfig.get('PREFERENCES', 'wrlog')):
            maxlogs = int(globalconfig.get('PREFERENCES', 'max_logs'))
            #Open scanlog
            scanlogf = open('etc/scan_log.txt','r')
            if len(scanlogf.read().split('*' + '-'*15 + '*\n\n')) <= maxlogs:
                scanlogout = open('etc/scan_log.txt','a')
            else:
                scanlogout = open('etc/scan_log.txt','w')

            #Compile details
            new_contents = []
            dates = localtime()
            new_contents.append('::SCAN DETAILS::\n\n')
            new_contents.append('Date:: %s/%s/%s\n' % (dates[2], dates[1], dates[0]))
            new_contents.append('Time:: %s:%s:%s\n' % (dates[3], dates[4], dates[5]))
            new_contents.append('Objects found:: %s\n' % statstore.get_value(statstore.get_iter(1), 1))
            new_contents.append('Objects ignored:: %s\n' % statstore.get_value(statstore.get_iter(4), 1))
            new_contents.append('Cookies checked:: %s\n' % statstore.get_value(statstore.get_iter(0), 1))

            #If necessary, compile object details
            if int(globalconfig.get('PREFERENCES','wrdet')):
                new_contents.append('------\n::OBJECT DETAILS::\n\n')
                for object in foundobj:
                    new_contents.append('Name::%s\nLocation::%s\n\n' % (object[3], object[4]))
            
            
            new_contents.append('*' + '-'*15 + '*\n\n')

            #Write out
            scanlogout.writelines(new_contents)
            scanlogout.close()
            scanlogf.close()

           
    def remove_tool(*items):
        
        def select_all(*items):
            #Select all items
            it, it2, it3 = 0, 0, 0
            count, count2, count3 = 1, 1, 1
            
            while count:
                try:
                    treestore.set_value(treestore.get_iter('%s' % (it)),1, True)
                except ValueError:
                    count = 0
                else:
                    count2 = 1
                    it2 = 0
                    while count2:
                        try:
                           treestore.set_value(treestore.get_iter('%s:%s' % (it, it2)),1, True)
                        except ValueError:
                            count2 = 0
                        else:
                            count3 = 1
                            it3 = 0
                            while count3:
                                try:
                                    treestore.set_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),1, True)
                                except ValueError:
                                    count3 = 0
                                it3 += 1
                        it2 += 1            
                it += 1
                          
        def remove_selected(*items):
            #Get all items selected
            it, it2, it3 = 0, 0, 0
            count, count2, count3 = 1, 1, 1
            currentprof = ''
            numrt = 0
            nump = 0
            numt = 0
            dberror = 0
            
            while count:
                #Skip this profile
                numthis = 0
                
                try:
                    treestore.get_iter('%s' % (it))
                except ValueError:
                    count = 0
                else:
                    #Gather profile details
                    profdetails = treestore.get_value(treestore.get_iter('%s' % (it)), 4).split(';')
                    currentprof = profiledict[profdetails[0]][int(profdetails[1])][1] #path
                    
                    #FIREFOX REMOVE ROUTINE
                    if profdetails[0] == "firefox":
                     #Open sql file
                     try:
                       con = sqlite.connect(currentprof)
                       cur = con.cursor()
                     except:
                        pass
                     else:
                    
                      #Url list
                      count2 = 1
                      it2 = 0
                      while count2:
                        try:
                           treestore.get_iter('%s:%s' % (it, it2))
                        except ValueError:
                            count2 = 0
                        else:
                            count3 = 1
                            it3 = 0
                            while count3:
                                try:
                                    treestore.get_iter('%s:%s:%s' % (it, it2, it3))
                                except ValueError:
                                    count3 = 0
                                else:
                                    #Object selected
                                    if treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),1) == True:
                                        #Delete cookie
                                        details = (treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),2), treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),2))
                                        try:
                                            cur.execute('DELETE FROM moz_cookies WHERE host=? AND name=?', details)
                                        
                                            #update stats
                                            numthis += 1
                                            numrt += 1
                                            if treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),4) == "1": numt += 1
                                            else: nump+= 1
                                        except:
                                            dberror = 1
                                        
                                        
                        
                                it3 += 1
                        it2 += 1            
                        
                    #GOOGLE CHROME REMOVE ROUTINE
                    elif profdetails[0] == "chrome":
                     #Open sql file
                     try:
                       con = sqlite.connect(currentprof)
                       cur = con.cursor()
                     except:
                        pass
                     else:
                    
                      #Url list
                      count2 = 1
                      it2 = 0
                      while count2:
                        try:
                           treestore.get_iter('%s:%s' % (it, it2))
                        except ValueError:
                            count2 = 0
                        else:
                            count3 = 1
                            it3 = 0
                            while count3:
                                try:
                                    treestore.get_iter('%s:%s:%s' % (it, it2, it3))
                                except ValueError:
                                    count3 = 0
                                else:
                                    #Object selected
                                    if treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),1) == True:
                                        #Delete cookie
                                        details = (treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),2), treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),2))
                                        
                                        try:
                                           cur.execute('DELETE FROM cookies WHERE host_key=? AND name=?', details)
                                        
                                           #update stats
                                           numthis += 1
                                           numrt += 1
                                           if treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),4) == "1": numt += 1
                                           else: nump+= 1
                                        except:
                                            dberror = 1
                                        
                                        
                        
                                it3 += 1
                        it2 += 1         
                        
                           
                    #IE REMOVE ROUTINE
                    elif profdetails[0] == "ie":
                      #Url list
                      count2 = 1
                      it2 = 0
                      opened = 0
                      while count2:
                        try:
                           treestore.get_iter('%s:%s' % (it, it2))
                        except ValueError:
                            count2 = 0
                        else:
                            count3 = 1
                            it3 = 0
                            opened = 0
                            while count3:
                                try:
                                    treestore.get_iter('%s:%s:%s' % (it, it2, it3))
                                except ValueError:
                                    count3 = 0
                                else:
                                    #Object selected
                                    if treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),1) == True:
                                        #Gather info
                                        details = (treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),2), treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),4), treestore.get_value(treestore.get_iter('%s:%s:%s' % (it, it2, it3)),2))
                                        
                                        #Open file containing
                                        if not opened: 
                                            cookieio = open(currentprof + "\\" + details[1], "r")
                                            cookiecont = cookieio.read()
                                            cookiecont = cookiecont.split("*\n")
                                            del cookiecont[-1]
                                            cookieio.close()
                                            opened = 1
                                            
                                        #Delete cookie
                                        objectid = 0
                                        for object in cookiecont:
                                            if object.split('\n')[0] == details[2]: 
                                                break
                                            else: 
                                                objectid += 1
                                            
                                        del cookiecont[objectid]
                                        
                                        if len(cookiecont) == 0:
                                            #if file is empty delete it
                                            try:
                                               remove(currentprof + "\\" + details[1])
                                            except:
                                                pass
                                        else:
                                            cookiew = open(currentprof + "\\" + details[1], "w")
                                            for cont in cookiecont:
                                                #write remaining cookies
                                                cookiew.write(cont)
                                                cookiew.write('*\n')
                                            cookiew.close()
                                        
                                        
                                        #update stats
                                        numthis += 1
                                        numrt += 1
                                        if treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)),4) == "1": numt += 1
                                        else: nump+= 1
                                        
                                        
                        
                                it3 += 1
                        it2 += 1   
                        
                    
                #End routine
                if (numthis > 0) and (profdetails[0] == "firefox" or profdetails[0] == "chrome"):
                    con.commit()
                    cur.close()
                    con.close()
                it += 1
            
            if numrt > 0:        


                  #Update globalconfig
                  globalconfig.set('GENERAL', 'num_removed_obj', str(int(globalconfig.get('GENERAL', 'num_removed_obj')) + int(numrt)))
                  globalconfig.set('GENERAL', 'num_tracking', str(int(globalconfig.get('GENERAL', 'num_tracking')) + int(numt)))
                  globalconfig.set('GENERAL', 'num_tracking_p', str(int(globalconfig.get('GENERAL', 'num_tracking_p')) + int(nump)))
                  globalconfig.write(open('etc/gconfig.cfg','w'))
               
                  #Close all windows
                  if currentStatus: actshield.start() #Important: resume active shield if it was running
                  gtk.Widget.destroy(rmwin)
                  gtk.Widget.destroy(win)
                  
            if numrt == 0 and not dberror:
                show_error(languageconfig.get('WINREMOVE', 'error_object'), rmwin, languageconfig.get('WINREMOVE','error_title'))
                
            if dberror:
                  #Could not remove some object. Maybe the user opened the browser by mistake?
                  show_error(languageconfig.get('WINREMOVE', 'error_delete'), trwin, languageconfig.get('WINREMOVE','error_title'))

        
        def check_toggled(widget, iter, *items):
            #Toggle check button
            treestore.set_value(treestore.get_iter(iter),1, bool(int(treestore.get_value(treestore.get_iter(iter),1)) - 1))
            
            #Toggle true/false all childs
            status = treestore.get_value(treestore.get_iter(iter),1)
            iter = str(iter).split(':')
            count = 1
            count2 = 1
            it = 0
            it2 = 0
            
            if len(iter) == 1:
                while count:
                      try:
                          treestore.set_value(treestore.get_iter('%s:%s' % (iter[0], it)),1, status)
                      except ValueError:
                          count = 0
                      else:
                          count2 = 1
                          it2 = 0
                          while count2:
                              try:
                                 treestore.set_value(treestore.get_iter('%s:%s:%s' % (iter[0], it, it2)),1, status)
                              except ValueError:
                                  count2 = 0
                              else:
                                  it2 += 1
                      it += 1
            
            if len(iter) == 2:
                    count2 = 1
                    while count2:
                        try:
                            treestore.set_value(treestore.get_iter('%s:%s:%s' % (iter[0], iter[1], it2)),1, status)
                        except ValueError:
                            count2 = 0
                        else:
                            it2 += 1
                            
                    
            #Disable parent if all childs are false
            urldisab = False
            if len(iter) == 3:
                pointit = 0
                i = 1
                while i:
                    try:
                        if treestore.get_value(treestore.get_iter("%s:%s:%s" % (iter[0], iter[1], pointit)), 1):
                            break
                        else:
                            pass
                    except ValueError:
                        i = 0
                    else:
                        pointit += 1
                else:
                    treestore.set_value(treestore.get_iter("%s:%s" % (iter[0], iter[1])), 1, False)
                    urldisab = True
                    
            #Disable parent if all childs are false
            if len(iter) == 2 or urldisab:
                pointit = 0
                i = 1
                while i:
                    try:
                        if treestore.get_value(treestore.get_iter("%s:%s" % (iter[0], pointit)), 1):
                            break
                        else:
                            pass
                    except ValueError:
                        i = 0
                    else:
                        pointit += 1
                else:
                    treestore.set_value(treestore.get_iter(iter[0]), 1, False)
           
            #If child was enabled enable parents
            if status and len(iter) == 3:
                if not treestore.get_value(treestore.get_iter("%s:%s" % (iter[0], iter[1])), 1): treestore.set_value(treestore.get_iter("%s:%s" % (iter[0], iter[1])), 1, True)
                if not treestore.get_value(treestore.get_iter(iter[0]), 1): treestore.set_value(treestore.get_iter(iter[0]), 1, True)
                
            if status and len(iter) == 2:
                if not treestore.get_value(treestore.get_iter(iter[0]), 1): treestore.set_value(treestore.get_iter(iter[0]), 1, True)
                
                   
                      
                      
        
        #Remove tool window
        #Global vars
        global foundobj
        
        #Window
        rmwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        rmwin.set_position(gtk.WIN_POS_CENTER)
        rmwin.connect("delete_event", delete_event)
        rmwin.set_default_size(491, 280)
        rmwin.set_resizable(True)
        rmwin.set_title(languageconfig.get('WINREMOVE','window_title'))
        rmwin.set_modal(True)
        rmwin.set_transient_for(win)

        #Remove section
        ###
        
        #Table
        rmtable = gtk.Table(3, 5, False)
        
        #build Tree treestore
        parentlist = {}
        treestore = gtk.TreeStore(gtk.gdk.Pixbuf, bool, str, str, str)
        for cookie in foundobj:
            #Add profile item
            it = 0
            count = 1
            cookiebrowser = cookie[0]
            cookieid = cookie[1]
            cookietype = cookie[2]
            cookiename = cookie[3]
            cookieurl = cookie[4]
            while count:
                try: 
                  if treestore.get_value(treestore.get_iter(it), 4) == str(";".join([cookiebrowser, str(cookieid)])):
                     break
                  else:
                     it += 1
                except ValueError:
                   count = 0
            else:
                parentlist[str(it)] = treestore.append(None, [gtk.gdk.pixbuf_new_from_file("%s/%s.png" % (nametheme, cookiebrowser)), None, str(profiledict[cookiebrowser][cookieid][0]), '', ";".join([cookiebrowser, str(cookieid)])])

            
            #Add url item
            count = 1
            it2 = 0
            while count:
                try:
                    if treestore.get_value(treestore.get_iter('%s:%s' % (it, it2)), 2) == cookieurl:
                        break
                    else:
                        it2 += 1
                except ValueError:
                    count = 0
                
            else:
                if cookietype == 1:
                    pixbuf = gtk.gdk.pixbuf_new_from_file("%s/folder_t.png" % nametheme)
                    type = 1
                else:
                    pixbuf = gtk.gdk.pixbuf_new_from_file("%s/folder_p.png" % nametheme)
                    type = 0
                parentlist['%s:%s' % (it, it2)] = treestore.append(parentlist[str(it)], [pixbuf, False, cookieurl, '', str(type)])
            
            #Add cookie item
            if cookietype == 1:
                pixbuf = gtk.gdk.pixbuf_new_from_file("%s/tracking_cookie.png" % nametheme)
                cookielabel = languageconfig.get("WINSCAN","tracking_type")
            else:
                pixbuf = gtk.gdk.pixbuf_new_from_file("%s/p_tracking_cookie.png" % nametheme)
                cookielabel = languageconfig.get("WINSCAN","tracking_type_p")
                
            if cookiebrowser == "ie": urldetail = cookie[5]
            else: urldetail = "" 
            treestore.append(parentlist['%s:%s' % (it, it2)], [pixbuf, False, cookiename, cookielabel, urldetail])
       
        
        #TreeView
        treeview = gtk.TreeView(treestore)
        treeview.set_rules_hint(True)
        
        #TreeViewColums
        columnbool = gtk.TreeViewColumn(None)
        columnstr = gtk.TreeViewColumn(languageconfig.get('MAINWINDOW','index_name') + " "*21)
        columnstr.set_resizable(True)
        columnstr2 = gtk.TreeViewColumn(languageconfig.get('WINSCAN','priority_name'))
        columnstr2.set_resizable(True)
        columnid = gtk.TreeViewColumn(None)
        columnid.set_visible(False)
        
        #Append columns
        treeview.append_column(columnbool)
        treeview.append_column(columnstr)
        treeview.append_column(columnstr2)
        treeview.append_column(columnid)
        
        #Cellrenderers
        cellpix = gtk.CellRendererPixbuf()
        cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
        cellbool = gtk.CellRendererToggle()
        cellbool.set_property('activatable', True)
        cellbool.connect('toggled', check_toggled, iter)
        cellstr = gtk.CellRendererText()
        cellstr.set_property("ellipsize-set", True)
        cellstr.set_property("ellipsize", ELLIPSIZE_END)
        cellstr2 = gtk.CellRendererText()
        cellstr2.set_property("ellipsize-set", True)
        cellstr2.set_property("ellipsize", ELLIPSIZE_END)
        cellid = gtk.CellRendererText()
        
        #Add cell renderers
        columnbool.pack_start(cellpix, True)
        columnbool.pack_start(cellbool, True)
        columnstr.pack_start(cellstr, True)
        columnstr2.pack_start(cellstr2, True)
        columnid.pack_start(cellid, True)
        
        #Set attributes
        columnbool.set_attributes(cellpix, pixbuf=0)
        columnbool.set_attributes(cellbool, active=1)
        columnstr.set_attributes(cellstr, text=2)
        columnstr2.set_attributes(cellstr2, text=3)
        columnid.set_attributes(cellid, text=4)
        
    	#Box Button Remove sel
	rmtbox = gtk.HBox(False, 0)
	rmtimage = gtk.Image()
	rmtimage.set_from_file('%s/rmtool.png' % nametheme)
	rmtlab = gtk.Label('  ' + languageconfig.get('WINREMOVE','remove_lab'))
	rmtbox.pack_start(rmtimage, False, 1)
	rmtbox.pack_start(rmtlab, True, 1)
	rmtbut = gtk.Button()
	rmtbut.add(rmtbox)
	rmtbut.connect('clicked', remove_selected)
	
	#Box Button Select all
	seabox = gtk.HBox(False, 0)
	seaimage = gtk.Image()
	seaimage.set_from_file('%s/select_all.png' % nametheme)
	sealab = gtk.Label('  ' + languageconfig.get('WINREMOVE','select_all'))
	seabox.pack_start(seaimage, False, 1)
	seabox.pack_start(sealab, True, 1)
	seabut = gtk.Button()
	seabut.add(seabox)
	seabut.connect('clicked', select_all)
	
	#Box Button Close
	closebox = gtk.HBox(False, 0)
	closeimage = gtk.Image()
	closeimage.set_from_file('%s/deny.png' % nametheme)
	closelab = gtk.Label('  ' + languageconfig.get('WINREMOVE','close_lab'))
	closebox.pack_start(closeimage, False, 1)
	closebox.pack_start(closelab, True, 1)
	closebut = gtk.Button()
	closebut.add(closebox)
	closebut.connect_object("clicked", gtk.Widget.destroy, rmwin)
	
	#Label
	rmlabel = gtk.Label(languageconfig.get('WINREMOVE','remove_obj'))
	
	#Button box
	brbox = gtk.HBox(False, 0)
	brbox.pack_start(rmtbut, False, 1)
	brbox.pack_start(seabut, False, 1)
	brbox.pack_start(closebut, False, 1)
	
	#Scrolled Window
	swin = gtk.ScrolledWindow(None, None)
	swin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
	swin.add(treeview)
	
	#Table show
	rmtable.attach(swin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	rmtable.attach(rmlabel, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
	rmtable.attach(brbox, 2, 3, 1, 2, gtk.FILL|gtk.FILL, gtk.FILL)
        
        #Add elements
        rmwin.add(rmtable)
        rmwin.show_all()
        
        
    def stop_now(*items):
        #The user has closed this window, let's stop scanning
        global stop
        stop = True
        
        #Resume protection if it was enabled
        if currentStatus: actshield.start()
    
    
    #Global vars
    global stop
    stop = False
    
    #Scan window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.set_position(gtk.WIN_POS_CENTER)
    win.connect("delete_event", stop_now)
    win.connect("delete_event", delete_event)
    win.set_default_size(510, 270)
    win.set_resizable(True)
    win.set_title(languageconfig.get('WINSCAN','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
    
    #Table
    table = gtk.Table(6, 5, False)
    
    #Separators
    hsep = gtk.HSeparator()
    hsep2 = gtk.HSeparator()
    
    #Progress bar
    bar1 = gtk.ProgressBar()
    bar1.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
    bar1.set_fraction(0.0)
    
    #Label 
    progresslab = gtk.Label() 
    progresslab.set_ellipsize(ELLIPSIZE_END)
                        
    #Box Button Close
    closebox = gtk.HBox(False, 0)
    closeimage = gtk.Image()
    closeimage.set_from_file('%s/deny.png' % nametheme)
    closelab = gtk.Label('  ' + languageconfig.get('WINSCAN','close_lab'))
    closebox.pack_start(closeimage, False, 1)
    closebox.pack_start(closelab, True, 1)
    closebut = gtk.Button()
    closebut.add(closebox)
    closebut.connect("clicked", stop_now)
    closebut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Box Button Scan
    scansbox = gtk.HBox(False, 0)
    scansimage = gtk.Image()
    scansimage.set_from_file('%s/start_scan.png' % nametheme)
    scanslab = gtk.Label('   ' + languageconfig.get('WINSCAN','scan_lab'))
    scansbox.pack_start(scansimage, False, 1)
    scansbox.pack_start(scanslab, True, 1)
    scansbut = gtk.Button()
    scansbut.add(scansbox)
    scansbut.connect('clicked', scan)
    
    #Box Button Remove
    rmbox = gtk.HBox(False, 0)
    rmimage = gtk.Image()
    rmimage.set_from_file('%s/rmtool.png' % nametheme)
    rmlab = gtk.Label(' ' + languageconfig.get('WINSCAN','remove_lab'))
    rmbox.pack_start(rmimage, False, 1)
    rmbox.pack_start(rmlab, True, 1)
    rmbut = gtk.Button()
    rmbut.add(rmbox)
    rmbut.set_sensitive(False)
    rmbut.connect('clicked', remove_tool)
    
    #Button box
    bpbox = gtk.HBox(False, 0)
    bpbox.pack_start(closebut, False, 1)
    bpbox.pack_start(scansbut, False, 1)
    bpbox.pack_start(rmbut, False, 1)
    
    #ListStore
    statstore = gtk.ListStore(gtk.gdk.Pixbuf, int, str)
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/ocheck.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_totchecked')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmfind.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_totfound')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/tracking_cookie.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_tracking')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/p_tracking_cookie.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_ptracking')])
    statstore.append([gtk.gdk.pixbuf_new_from_file("%s/dmignored.png" % nametheme) ,0, languageconfig.get('WINSCAN','scan_ignfound')])
    
    
    #TreeView
    foundobj, filelisto = None, None
    statview = gtk.TreeView(statstore)
    statview.set_rules_hint(True)
    statview.set_headers_clickable(False)
    
    
    #TreeViewColums
    columnum = gtk.TreeViewColumn('            ')
    columnum.set_resizable(True)
    columndet = gtk.TreeViewColumn(languageconfig.get('WINSCAN','top_scan') + ' ' * 10)
    columndet.set_resizable(True)
    
    #Append columns
    statview.append_column(columnum)
    statview.append_column(columndet)
    
    #Cellrenderers2
    cellimg = gtk.CellRendererPixbuf()
    cellnum = gtk.CellRendererText()
    celldet = gtk.CellRendererText()
    
    #add cell renderers
    columnum.pack_start(cellimg, True)
    columnum.pack_start(cellnum, True)
    columndet.pack_start(celldet, True)
    
    #set attributes
    columnum.set_attributes(cellimg, pixbuf=0)
    columnum.set_attributes(cellnum, text=1)
    columndet.set_attributes(celldet, text=2)
    cellimg.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
    #Build profile dictionary
    #Browser -> tuple list of profiles
    profiledict = {}
    firefoxlist = []
    ielist = []
    chromelist = []
    profilenum = 0
    profiles = globalconfig.get("USER","profiles").split("||") #Profile format: name, path, browser, enabled
    del profiles[-1]
    
    for profile in profiles:
        
        profile = profile.split('|')
        #Check if enabled
        if bool(int(profile[3])):
            if profile[2] == "firefox": firefoxlist.append((profile[0], profile[1]))
            if profile[2] == "ie": ielist.append((profile[0], profile[1]))
            if profile[2] == "chrome": chromelist.append((profile[0], profile[1]))
            profilenum += 1
    #Build
    profiledict["firefox"] = tuple(firefoxlist)
    profiledict["chrome"] = tuple(chromelist)
    profiledict["ie"] = tuple(ielist)
    
    #No profile selected
    if profilenum == 0:
       progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_noprof')))
       scansbut.set_sensitive(False)
    else:
       progresslab.set_markup(':::<b>%s</b>: %s' % (languageconfig.get('WINSCAN','status'), languageconfig.get('WINSCAN','status_selprof').replace("NUM", str(profilenum))))
    
    
    #Show 
    table.attach(statview, 0, 5, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
    table.attach(progresslab, 1, 5, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    table.attach(bar1, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    table.attach(bpbox, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
    table.attach(hsep, 0, 5, 2, 3, gtk.FILL, 0)
    table.attach(hsep2, 0, 5, 4, 5, gtk.FILL, 0)
    win.add(table)
    win.show_all()
    
    #Focus
    win.set_focus(None)
    
    #For stabilty reasons, temporaly disable active protection when the user opens this window
    currentStatus = actshield.isRunning
    if currentStatus: actshield.stop()